#
# This file is part of GNU Enterprise.
#
# GNU Enterprise is free software; you can redistribute it
# and/or modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2, or (at your option) any later version.
#
# GNU Enterprise is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE. See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with program; see the file COPYING. If not,
# write to the Free Software Foundation, Inc., 59 Temple Place
# - Suite 330, Boston, MA 02111-1307, USA.
#
# Copyright 2001-2002 Free Software Foundation
#
# FILE:
# reports/TemplateSupport.py
#
# DESCRIPTION:
# Provides reports-specific extensions to TemplateBase
#
# NOTES:
#

from gnue.designer.TemplateBase import *
import Incubator
from gnue.reports.GRReport import GRReport
from gnue.common import GParserHelpers
from gnue.reports import GRLayout
# TODO
def createRootObject(instance):
  return GRReport.GRReport()



###########################################################
#
# Base class for a report template
#
###########################################################
class ReportTemplate(TemplateBase):

  # Initialize user code
  def Start(self, root):
    pass


  def AddContent(self, parent, content):
    GParserHelpers.GContent(parent, content)

  def AddElement(self, tag, parent, attributes={}, ns=None):
    if ns:
      o = GRLayout.GRPassThru(parent)
      o._xmltag = tag
      o._xmlnamespace = ns
      o._listedAttributes = attributes.keys()
    else:
      o = self.parser.elements[tag]['BaseClass'](parent)
      
    o.__dict__.update(attributes)
    o._buildObject()
    self.parser.instance.onCreateObject(o, __name__)
    return o

